diff --git a/game/core/src/main/java/net/minecraft/core/entity/EntityItem.java b/game/core/src/main/java/net/minecraft/core/entity/EntityItem.java
index ee0532c76..c28403b42 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/EntityItem.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/EntityItem.java
@@ -8,16 +8,16 @@ import net.minecraft.core.achievement.stat.StatList;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockLogicLog;
 import net.minecraft.core.block.Blocks;
-import net.minecraft.core.block.material.Material;
+import net.minecraft.core.block.material.Materials;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.item.ItemDiscMusic;
 import net.minecraft.core.item.Items;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.util.helper.DamageType;
 import net.minecraft.core.util.helper.MathHelper;
-import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.World;
 import org.jetbrains.annotations.NotNull;
+import org.joml.primitives.AABBd;
 
 public class EntityItem extends Entity
 {
@@ -32,17 +32,17 @@ public class EntityItem extends Entity
 
     public EntityItem(World world, double x, double y, double z, ItemStack itemstack) {
         super(world);
-        age = 0;
-        health = 8;
-        bobOffset = (float)(Math.random() * Math.PI * 2D);
+        this.age = 0;
+        this.health = 8;
+        this.bobOffset = (float)(Math.random() * Math.PI * 2D);
         setSize(0.25F, 0.25F);
-        heightOffset = bbHeight / 2.0F;
+        this.heightOffset = this.bbHeight / 2.0F;
         setPos(x, y, z);
-        item = itemstack;
-        yRot = (float)(Math.random() * 360D);
-        xd = (float)(Math.random() * 0.2D - 0.1D);
-        yd = 0.2D;
-        zd = (float)(Math.random() * 0.2D - 0.1D);
+        this.item = itemstack;
+        this.yRot = (float)(Math.random() * 360D);
+        this.xd = (float)(Math.random() * 0.2D - 0.1D);
+        this.yd = 0.2D;
+        this.zd = (float)(Math.random() * 0.2D - 0.1D);
         if(itemstack == null) {
         	System.err.println("Created EntityItem with no item!");
         	Thread.dumpStack();
@@ -58,11 +58,11 @@ public class EntityItem extends Entity
     public EntityItem(World world)
     {
         super(world);
-        age = 0;
-        health = 5;
-        bobOffset = (float)(Math.random() * Math.PI * 2D);
+        this.age = 0;
+        this.health = 5;
+        this.bobOffset = (float)(Math.random() * Math.PI * 2D);
         setSize(0.25F, 0.25F);
-        heightOffset = bbHeight / 2.0F;
+        this.heightOffset = this.bbHeight / 2.0F;
     }
 
     @Override
@@ -74,74 +74,74 @@ public class EntityItem extends Entity
 	public void tick()
     {
         super.tick();
-        if(item == null) {
+        if(this.item == null) {
             System.err.println("Removing EntityItem with no item!");
             Thread.dumpStack();
             remove();
             return;
         }
-        if(item.stackSize <= 0) {
+        if(this.item.stackSize <= 0) {
         	remove();
         	return;
         }
         
         
-        if(pickupDelay > 0)
+        if(this.pickupDelay > 0)
         {
-            pickupDelay--;
+            this.pickupDelay--;
         }
-        xo = x;
-        yo = y;
-        zo = z;
-        yd -= 0.04D;
+        this.xo = this.x;
+        this.yo = this.y;
+        this.zo = this.z;
+        this.yd -= 0.04D;
         if(isInLava())
         {
-            yd = 0.2D;
-            xd = (random.nextFloat() - random.nextFloat()) * 0.2F;
-            zd = (random.nextFloat() - random.nextFloat()) * 0.2F;
-            world.playSoundAtEntity(null, this, "random.fizz", 0.4F, 2.0F + random.nextFloat() * 0.4F);
+            this.yd = 0.2D;
+            this.xd = (this.random.nextFloat() - this.random.nextFloat()) * 0.2F;
+            this.zd = (this.random.nextFloat() - this.random.nextFloat()) * 0.2F;
+            this.world.playSoundAtEntity(null, this, "random.fizz", 0.4F, 2.0F + this.random.nextFloat() * 0.4F);
         }
 
-        checkInTile(x, (bb.minY + bb.maxY) / 2D, z);
-        move(xd, yd, zd);
+        checkInTile(this.x, (this.bb.minY + this.bb.maxY) / 2D, this.z);
+        move(this.xd, this.yd, this.zd);
         
-        if(!world.isClientSide) {
+        if(!this.world.isClientSide) {
         	if(enableItemClumping) {
-                if(MathHelper.floor(x) != MathHelper.floor(xo) || MathHelper.floor(y) != MathHelper.floor(yo) || MathHelper.floor(z) != MathHelper.floor(zo) || age % 25 == 0) {
+                if(MathHelper.floor(this.x) != MathHelper.floor(this.xo) || MathHelper.floor(this.y) != MathHelper.floor(this.yo) || MathHelper.floor(this.z) != MathHelper.floor(this.zo) || this.age % 25 == 0) {
                 	clumpToNearbyStack();
                 }		
         	}
         }
         
         float friction = 0.98F;
-        if(onGround)
+        if(this.onGround)
         {
             friction = 0.588F;
-            int blockId = world.getBlockId(MathHelper.floor(x), MathHelper.floor(bb.minY) - 1, MathHelper.floor(z));
+            int blockId = this.world.getBlockId(MathHelper.floor(this.x), MathHelper.floor(this.bb.minY) - 1, MathHelper.floor(this.z));
             if(blockId > 0)
             {
                 friction = Blocks.blocksList[blockId].friction * 0.98F;
             }
         }
-        xd *= friction;
-        yd *= 0.98D;
-        zd *= friction;
+        this.xd *= friction;
+        this.yd *= 0.98D;
+        this.zd *= friction;
 
-        if (wasInWater)
+        if (this.wasInWater)
         {
-            if(yd < 0.0f) {
-            	xd *= 0.95f;
-            	yd *= 0.45f;
-            	zd *= 0.95f;
+            if(this.yd < 0.0f) {
+                this.xd *= 0.95f;
+                this.yd *= 0.45f;
+                this.zd *= 0.95f;
             }
         }
 
-        if(onGround)
+        if(this.onGround)
         {
-            yd *= -0.5D;
+            this.yd *= -0.5D;
         }
-        age++;
-        if(age >= LIFETIME)
+        this.age++;
+        if(this.age >= LIFETIME)
         {
             remove();
         }
@@ -150,7 +150,7 @@ public class EntityItem extends Entity
     @Override
 	public boolean checkAndHandleWater(boolean addVelocity)
     {
-        return world.handleMaterialAcceleration(bb, Material.water, this, addVelocity);
+        return this.world.handleMaterialAcceleration(this.bb, Materials.WATER, this, addVelocity);
     }
 
     @Override
@@ -163,8 +163,8 @@ public class EntityItem extends Entity
     public boolean hurt(Entity entity, int i, DamageType type)
     {
         markHurt();
-        health -= i;
-        if(health <= 0)
+        this.health -= i;
+        if(this.health <= 0)
         {
             remove();
         }
@@ -174,61 +174,61 @@ public class EntityItem extends Entity
     @Override
 	public void addAdditionalSaveData(@NotNull CompoundTag tag)
     {
-        tag.putShort("Health", (byte)health);
-        tag.putShort("Age", (short)age);
-        if(item != null) {
-        	tag.putCompound("Item", item.writeToNBT(new CompoundTag()));
+        tag.putShort("Health", (byte) this.health);
+        tag.putShort("Age", (short) this.age);
+        if(this.item != null) {
+        	tag.putCompound("Item", this.item.writeToNBT(new CompoundTag()));
         }
     }
 
     @Override
 	public void readAdditionalSaveData(@NotNull CompoundTag tag)
     {
-        health = tag.getShort("Health") & 0xff;
-        age = tag.getShort("Age");
+        this.health = tag.getShort("Health") & 0xff;
+        this.age = tag.getShort("Age");
         if(tag.containsKey("Item")) {
-            item = ItemStack.readItemStackFromNbt(tag.getCompound("Item"));
+            this.item = ItemStack.readItemStackFromNbt(tag.getCompound("Item"));
         }
     }
 
 	@Override
 	public void playerTouch(Player player) {
-		if(world.isClientSide) {
+		if(this.world.isClientSide) {
 			return;
 		}
-		if(pickupDelay == 0) {
-			int previousStackSize = item.stackSize;
-			player.inventory.insertItem(item, true);
+		if(this.pickupDelay == 0) {
+			int previousStackSize = this.item.stackSize;
+			player.inventory.insertItem(this.item, true);
 
-			if(item.stackSize < previousStackSize) {
-				if(item.itemID < 16384) {
-                    Block<?> b = Blocks.blocksList[item.itemID];
+			if(this.item.stackSize < previousStackSize) {
+				if(this.item.itemID < 16384) {
+                    Block<?> b = Blocks.blocksList[this.item.itemID];
 					if(b != null && b.getLogic() instanceof BlockLogicLog) {
 						player.triggerAchievement(Achievements.MINE_WOOD);
 					}
 				}
-				if(item.itemID == Items.LEATHER.id) {
+				if(this.item.itemID == Items.LEATHER.id) {
 					player.triggerAchievement(Achievements.KILL_COW);
 				}
-                if(item.itemID == Items.DIAMOND.id) {
+                if(this.item.itemID == Items.DIAMOND.id) {
                     player.triggerAchievement(Achievements.GET_DIAMONDS);
                 }
-                if(item.itemID == Items.NETHERCOAL.id) {
+                if(this.item.itemID == Items.NETHERCOAL.id) {
                     player.triggerAchievement(Achievements.GET_NETHERCOAL);
                 }
-				if(item.itemID == Blocks.ICE.id()) {
+				if(this.item.itemID == Blocks.ICE.id()) {
 					player.triggerAchievement(Achievements.CRUSH_BLOCKS);
 				}
 				
-				if(item.stackSize <= 0) {
-					world.playSoundAtEntity(player, this, "item.pickup", 1F, ((random.nextFloat() - random.nextFloat()) * 0.7F + 1.0F) * 4.0F);
-					player.onItemPickup(this, item);
+				if(this.item.stackSize <= 0) {
+                    this.world.playSoundAtEntity(player, this, "item.pickup", 1F, ((this.random.nextFloat() - this.random.nextFloat()) * 0.7F + 1.0F) * 4.0F);
+					player.onItemPickup(this, this.item);
 				}
 
-				if(item.itemID == Items.LANTERN_FIREFLY_GREEN.id
-						|| item.itemID == Items.LANTERN_FIREFLY_BLUE.id
-						|| item.itemID == Items.LANTERN_FIREFLY_ORANGE.id
-						|| item.itemID == Items.LANTERN_FIREFLY_RED.id) {
+				if(this.item.itemID == Items.LANTERN_FIREFLY_GREEN.id
+						|| this.item.itemID == Items.LANTERN_FIREFLY_BLUE.id
+						|| this.item.itemID == Items.LANTERN_FIREFLY_ORANGE.id
+						|| this.item.itemID == Items.LANTERN_FIREFLY_RED.id) {
 					if( player.getStat(Items.LANTERN_FIREFLY_RED.getStat(StatList.STAT_PICKED_UP)) > 0 &&
                             player.getStat(Items.LANTERN_FIREFLY_GREEN.getStat(StatList.STAT_PICKED_UP)) > 0 &&
                             player.getStat(Items.LANTERN_FIREFLY_BLUE.getStat(StatList.STAT_PICKED_UP)) > 0 &&
@@ -237,7 +237,7 @@ public class EntityItem extends Entity
 					}
 				}
 
-                if (item.getItem() instanceof ItemDiscMusic) {
+                if (this.item.getItem() instanceof ItemDiscMusic) {
                     if( player.getStat(Items.RECORD_13.getStat(StatList.STAT_PICKED_UP)) > 0 &&
                         player.getStat(Items.RECORD_CAT.getStat(StatList.STAT_PICKED_UP)) > 0 &&
                         player.getStat(Items.RECORD_BLOCKS.getStat(StatList.STAT_PICKED_UP)) > 0 &&
@@ -255,7 +255,7 @@ public class EntityItem extends Entity
                     }
                 }
 
-				if(item.stackSize <= 0) {
+				if(this.item.stackSize <= 0) {
 					remove();
 				}
 			}
@@ -263,8 +263,8 @@ public class EntityItem extends Entity
 	}
 
     public void clumpToNearbyStack() {
-    	AABB boundingBox = this.bb.grow(0.5, 0.0, 0.5);
-    	List<@NotNull EntityItem> entities = world.getEntitiesWithinAABB(EntityItem.class, boundingBox);
+    	AABBd boundingBox = MathHelper.aabbGrow(this.bb, 0.5, 0.0, 0.5, new AABBd());
+    	List<@NotNull EntityItem> entities = this.world.getEntitiesWithinAABB(EntityItem.class, boundingBox);
     	
     	for(EntityItem otherEntity : entities) {
     		if(otherEntity == this || !otherEntity.isAlive() || !this.isAlive()) {
diff --git a/game/core/src/main/java/net/minecraft/core/entity/EntityLightning.java b/game/core/src/main/java/net/minecraft/core/entity/EntityLightning.java
index 49b91bea7..3a87f4948 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/EntityLightning.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/EntityLightning.java
@@ -4,128 +4,110 @@ import net.minecraft.core.entity.animal.MobWolf;
 import net.minecraft.core.enums.Difficulty;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.sound.SoundCategory;
-import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.util.helper.MathHelper;
 import com.mojang.nbt.tags.CompoundTag;
-import net.minecraft.core.util.phys.Vec3;
 import net.minecraft.core.world.World;
 import org.jetbrains.annotations.NotNull;
+import org.joml.Vector3dc;
+import org.joml.primitives.AABBd;
 
 import java.util.List;
 
-public class EntityLightning extends Entity
-{
+public class EntityLightning extends Entity {
     private int life;
     public long seed;
     private int flashes;
-    public EntityLightning(World world){
-        this(world,0, 0, 0);
+
+    public EntityLightning(World world) {
+        this(world, 0, 0, 0);
     }
 
-    public EntityLightning(World world, double x, double y, double z)
-    {
+    public EntityLightning(World world, double x, double y, double z) {
         super(world);
-        seed = 0L;
+        this.seed = 0L;
         moveTo(x, y, z, 0.0F, 0.0F);
-        life = 2;
-        seed = random.nextLong();
-        flashes = random.nextInt(3) + 1;
+        this.life = 2;
+        this.seed = this.random.nextLong();
+        this.flashes = this.random.nextInt(3) + 1;
     }
 
     @Override
-	public void tick()
-    {
+    public void tick() {
         super.tick();
-        if(life == 2)
-        {
-            world.playSoundEffect(null, SoundCategory.WEATHER_SOUNDS, x, y, z, "ambient.weather.thunder", 10000F, 0.8F + random.nextFloat() * 0.2F);
-            world.playSoundEffect(null, SoundCategory.WEATHER_SOUNDS, x, y, z, "random.explode", 2.0F, 0.5F + random.nextFloat() * 0.2F);
-            for (int i = 0; i < world.entities.size(); i++) {
-                Entity e = world.entities.get(i);
+        if (this.life == 2) {
+            this.world.playSoundEffect(null, SoundCategory.WEATHER_SOUNDS, this.x, this.y, this.z, "ambient.weather.thunder", 10000F, 0.8F + this.random.nextFloat() * 0.2F);
+            this.world.playSoundEffect(null, SoundCategory.WEATHER_SOUNDS, this.x, this.y, this.z, "random.explode", 2.0F, 0.5F + this.random.nextFloat() * 0.2F);
+            for (int i = 0; i < this.world.entities.size(); i++) {
+                Entity e = this.world.entities.get(i);
                 if (e instanceof MobWolf) {
                     ((MobWolf) e).whine();
                 }
             }
         }
-        life--;
-        if(life < 0)
-        {
-            if(flashes == 0)
-            {
+        this.life--;
+        if (this.life < 0) {
+            if (this.flashes == 0) {
                 remove();
-            }
-            else if(life < -random.nextInt(10))
-            {
-                flashes--;
-                life = 1;
-                seed = random.nextLong();
-                if(world.areBlocksLoaded(MathHelper.floor(x), MathHelper.floor(y), MathHelper.floor(z), 10))
-                {
-                    int i = MathHelper.floor(x);
-                    int j = MathHelper.floor(y);
-                    int k = MathHelper.floor(z);
-                    if(world.getBlockId(i, j, k) == 0 && Blocks.FIRE.canPlaceBlockAt(world, i, j, k))
-                    {
-                        world.setBlockWithNotify(i, j, k, Blocks.FIRE.id());
+            } else if (this.life < -this.random.nextInt(10)) {
+                this.flashes--;
+                this.life = 1;
+                this.seed = this.random.nextLong();
+                if (this.world.areBlocksLoaded(MathHelper.floor(this.x), MathHelper.floor(this.y), MathHelper.floor(this.z), 10)) {
+                    int i = MathHelper.floor(this.x);
+                    int j = MathHelper.floor(this.y);
+                    int k = MathHelper.floor(this.z);
+                    if (this.world.getBlockId(i, j, k) == 0 && Blocks.FIRE.canPlaceBlockAt(this.world, i, j, k)) {
+                        this.world.setBlockWithNotify(i, j, k, Blocks.FIRE.id());
                     }
                 }
             }
         }
-        if(life >= 0)
-        {
+        if (this.life >= 0) {
             double radius = 3D;
-            List<Entity> list = world.getEntitiesWithinAABBExcludingEntity(this, AABB.fromPool(x - radius, y - radius, z - radius, x + radius, y + 6D + radius, z + radius));
-            for (Entity entity : list)
-            {
+            List<Entity> list = this.world.getEntitiesWithinAABBExcludingEntity(this, new AABBd(this.x - radius, this.y - radius, this.z - radius, this.x + radius, this.y + 6D + radius, this.z + radius));
+            for (Entity entity : list) {
                 entity.thunderHit(this);
             }
 
-            world.lightningFlicker = 2;
+            this.world.lightningFlicker = 2;
         }
     }
+
     @Override
-    protected void defineSynchedData(){
+    protected void defineSynchedData() {
 
     }
 
     @Override
-    public void spawnInit()
-    {
-        if(world.getDifficulty().id() >= Difficulty.NORMAL.id() && world.areBlocksLoaded(MathHelper.floor(x), MathHelper.floor(y), MathHelper.floor(z), 10))
-        {
-            int i = MathHelper.floor(x);
-            int k = MathHelper.floor(y);
-            int i1 = MathHelper.floor(z);
-            if(world.getBlockId(i, k, i1) == 0 && Blocks.FIRE.canPlaceBlockAt(world, i, k, i1))
-            {
-                world.setBlockWithNotify(i, k, i1, Blocks.FIRE.id());
+    public void spawnInit() {
+        if (this.world.getDifficulty().id() >= Difficulty.NORMAL.id() && this.world.areBlocksLoaded(MathHelper.floor(this.x), MathHelper.floor(this.y), MathHelper.floor(this.z), 10)) {
+            int i = MathHelper.floor(this.x);
+            int k = MathHelper.floor(this.y);
+            int i1 = MathHelper.floor(this.z);
+            if (this.world.getBlockId(i, k, i1) == 0 && Blocks.FIRE.canPlaceBlockAt(this.world, i, k, i1)) {
+                this.world.setBlockWithNotify(i, k, i1, Blocks.FIRE.id());
             }
-            for(int j = 0; j < 4; j++)
-            {
-                int l = (MathHelper.floor(x) + random.nextInt(3)) - 1;
-                int j1 = (MathHelper.floor(y) + random.nextInt(3)) - 1;
-                int k1 = (MathHelper.floor(z) + random.nextInt(3)) - 1;
-                if(world.getBlockId(l, j1, k1) == 0 && Blocks.FIRE.canPlaceBlockAt(world, l, j1, k1))
-                {
-                    world.setBlockWithNotify(l, j1, k1, Blocks.FIRE.id());
+            for (int j = 0; j < 4; j++) {
+                int l = (MathHelper.floor(this.x) + this.random.nextInt(3)) - 1;
+                int j1 = (MathHelper.floor(this.y) + this.random.nextInt(3)) - 1;
+                int k1 = (MathHelper.floor(this.z) + this.random.nextInt(3)) - 1;
+                if (this.world.getBlockId(l, j1, k1) == 0 && Blocks.FIRE.canPlaceBlockAt(this.world, l, j1, k1)) {
+                    this.world.setBlockWithNotify(l, j1, k1, Blocks.FIRE.id());
                 }
             }
         }
     }
 
     @Override
-	public void readAdditionalSaveData(@NotNull CompoundTag tag)
-    {
+    public void readAdditionalSaveData(@NotNull CompoundTag tag) {
     }
 
     @Override
-    public void addAdditionalSaveData(@NotNull CompoundTag tag)
-    {
+    public void addAdditionalSaveData(@NotNull CompoundTag tag) {
     }
 
     @Override
-	public boolean shouldRender(Vec3 vec3, double viewDistanceModifier)
-    {
-        return life >= 0;
+    public boolean shouldRender(@NotNull Vector3dc cameraPos, double viewDistanceModifier) {
+        return this.life >= 0;
     }
 }
